
; Copyright (C) 2018 Freetech Solutions

; This file is part of OMniLeads

; This program is free software: you can redistribute it and/or modify
; it under the terms of the GNU General Public License as published by
; the Free Software Foundation, either version 3 of the License, or
; (at your option) any later version.

; This program is distributed in the hope that it will be useful,
; but WITHOUT ANY WARRANTY; without even the implied warranty of
; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
; GNU General Public License for more details.

; You should have received a copy of the GNU General Public License
; along with this program.  If not, see http://www.gnu.org/licenses/.

; PREVIEW CALLS RIP CHANNELS PREVIEW CALLS RIP CHANNELS PREVIEW CALLS RIP CHANNELS PREVIEW CALLS RIP CHANNELS PREVIEW CALLS RIP CHANNELS PREVIEW CALLS RIP CHANNELS
; PREVIEW CALLS RIP CHANNELS PREVIEW CALLS RIP CHANNELS PREVIEW CALLS RIP CHANNELS PREVIEW CALLS RIP CHANNELS PREVIEW CALLS RIP CHANNELS PREVIEW CALLS RIP CHANNELS
; PREVIEW CALLS RIP CHANNELS PREVIEW CALLS RIP CHANNELS PREVIEW CALLS RIP CHANNELS PREVIEW CALLS RIP CHANNELS PREVIEW CALLS RIP CHANNELS PREVIEW CALLS RIP CHANNELS
; PREVIEW CALLS RIP CHANNELS PREVIEW CALLS RIP CHANNELS PREVIEW CALLS RIP CHANNELS PREVIEW CALLS RIP CHANNELS PREVIEW CALLS RIP CHANNELS PREVIEW CALLS RIP CHANNELS

[rip-preview-agent-chan]
include => rip-preview-agent-chan-custom

exten => s,1,Verbose(2, Previe call Agent Chan RIP)
same => n,Set(DB(OML/AGENT/${OMLAGENTID}/STATUS)=READY:${EPOCH})
same => n,Gosub(sub-oml-hangup,s,1)

[rip-preview-trunk-chan]
include => rip-preview-trunk-chan-custom

exten => s,1,Verbose(2, Previe call Trunk Chan RIP)
same => n,Gosub(sub-oml-hangup,s,1)


[rip-preview-originate-dialout-chan]
include => rip-preview-originate-dialout-chan-custom

exten => s,1,Verbose(2, As above, So Below - CHANNEL5)
same => n,Verbose(2, OML ----preview---> DIAL(SIP/trunk/OUTNUM)  | ${GLOBAL(${OMLAGENTSIP}result)})
same => n,Gosub(sub-oml-hangup,s,1(NORMAL CLEARING - ${CONTEXT}))


[rip-preview-originate-agent-chan]
include => rip-preview-originate-agent-chan-custom

exten => s,1,Verbose(2, As above, So Below - CHANNEL6)
same => n,Verbose(2, AGENT <---preview---- OML  | ${SHARED(OMLCALLSTATUS,${OMLMOTHERCHAN})})
same => n,Verbose(2, quien corto la llamada: ${SHARED(OMLSIDEHANGUP,${CHANNEL})})

same => n,GotoIf($["${OMLCAMPREC}" != "True"]?checkResult)
same => n,StopMixMonitor(${OMLRECFILENAME}.wav)

same => n(checkResult),Verbose(2, check resultado de llamada DIALSTATUS: ${SHARED(OMLCALLSTATUS,${CHANNEL})} - ${OMLCALLSTATUS})
same => n,GotoIf($["${SHARED(OMLCALLSTATUS,${CHANNEL})}" == "ANSWER"]?answer)
same => n,GotoIf($["${CUT(SHARED(OMLCALLSTATUS,${CHANNEL}),-,1)}" == "BT"]?blindTransfer)
same => n,GotoIf($["${CUT(SHARED(OMLCALLSTATUS,${CHANNEL}),-,1)}" == "CT"]?consultTransfer)
same => n,GotoIf($["${CUT(SHARED(OMLCALLSTATUS,${CHANNEL}),-,1)}" == "CAMPT"]?campTransfer)
same => n,GotoIf($["${CUT(SHARED(OMLCALLSTATUS,${CHANNEL}),-,1)}" == "BTOUT"]?blindTransferOutCall)
same => n,GotoIf($["${CUT(SHARED(OMLCALLSTATUS,${CHANNEL}),-,1)}" == "CTOUT"]?consultTransferOutCall)

same => n,Set(OMLCALLWAITDURATION=$[${EPOCH} - ${OMLYEARZERO}])
same => n,Gosub(sub-oml-queuelog,s,1(${OMLCAMPID},${OMLUNIQUEID},${OMLAGENTID},${SHARED(OMLCALLSTATUS,${CHANNEL})},${OMLOUTNUM},${OMLCODCLI},${OMLCALLTYPEID},${OMLCAMPTYPE},${OMLCALLWAITDURATION},,,call))
same => n,Gosub(sub-oml-hangup,s,1)

same => n(answer),Set(OMLCALLDURATION=$[${EPOCH} - ${SHARED(OMLANSWERTIMESTAMP,${OMLMOTHERCHAN})}])
same => n,Set(OMLCALLWAITDURATION=${SHARED(OMLCALLWAITDURATION,${OMLMOTHERCHAN})})
same => n,ExecIf($["${SHARED(OMLRECFILENAME,${CHANNEL})}" != ""]?Set(OMLRECFILENAME=${SHARED(OMLRECFILENAME,${CHANNEL})}))
same => n,GotoIf($["${OMLRECFILENAME}" == ""]?queueLogPreviewCall)

same => n,StopMixMonitor(${OMLRECFILENAME}.wav)
same => n,AGI(omni-grabaciones.py,${OMLCALLTYPEID},${OMLCODCLI},${OMLOUTNUM},${OMLRECFILENAME},${OMLAGENTID},${OMLCAMPID},${STRFTIME(${EPOCH},,%Y-%m-%d %H:%M:%S)},${OMLUNIQUEID},${OMLCALLDURATION})

same => n(queueLogPreviewCall),Verbose(2, hangedup part ${SHARED(OMLSIDEHANGUP,${CHANNEL})})
same => n,ExecIf($["${SHARED(OMLSIDEHANGUP,${CHANNEL})}" == "1"]?Set(COMPLETE=COMPLETEOUTNUM):Set(COMPLETE=COMPLETEAGENT))
same => n,Gosub(sub-oml-queuelog,s,1(${OMLCAMPID},${OMLUNIQUEID},${OMLAGENTID},${COMPLETE},${OMLOUTNUM},${OMLCODCLI},${OMLCALLTYPEID},${OMLCAMPTYPE},${OMLCALLWAITDURATION},${OMLCALLDURATION},${OMLRECFILENAME},call))
same => n,Gosub(sub-oml-hangup,s,1)


; tratamiento post-call de llamadas Preview transferidas de manera ciega hacia otro agente
same => n(blindTransfer),Verbose(2, ${CHANNEL} muere en una BT)
same => n,GotoIf($["${SHARED(OMLCALLSTATUS,${CHANNEL})}" != "BT-ANSWER"]?btUnanswer:btAnswer)

same => n(btUnanswer),Set(OMLCALLWAITDURATION=$[${EPOCH} - ${OMLYEARZEROTRANSFER}])
same => n,ExecIf($["${OMLCALLSTATUS}" == "BT-TRY"]?Set(OMLCALLSTATUS=BT-ABANDON))
same => n,Gosub(sub-oml-queuelog,s,1(${OMLCAMPID},${OMLUNIQUEID},${OMLAGENTTRANSFERDSTID},${OMLCALLSTATUS},${OMLOUTNUM},${OMLCODCLI},${OMLCALLTYPEID},${OMLCAMPTYPE},${OMLCALLWAITDURATION},${OMLCALLDURATION},${OMLRECFILENAME},call))
same => n,Gosub(sub-oml-hangup,s,1)

same => n(btAnswer),Set(OMLCALLWAITDURATION=${SHARED(OMLCALLWAITDURATION,${CHANNEL})})
same => n,Set(OMLCALLDURATION=$[${EPOCH} -  ${SHARED(OMLTRANSFERANSWERTIMESTAMP,${CHANNEL})}])
same => n,AGI(omni-grabaciones.py,${OMLCALLTYPEID},${OMLCODCLI},${OMLOUTNUM},${OMLRECFILENAME},${OMLAGENTID},${OMLCAMPID},${STRFTIME(${EPOCH},,%Y-%m-%d %H:%M:%S)},${OMLUNIQUEID},${OMLCALLDURATION})
same => n,Set(COMPLETE=COMPLETE-BT)
same => n,Gosub(sub-oml-queuelog,s,1(${OMLCAMPID},${OMLUNIQUEID},${OMLAGENTTRANSFERDSTID},${COMPLETE},${OMLOUTNUM},${OMLCODCLI},8,${OMLCAMPTYPE},${OMLCALLWAITDURATION},${OMLCALLDURATION},${OMLRECFILENAME},call))
same => n,Gosub(sub-oml-hangup,s,1(NORMAL CLEARING - ${CONTEXT}))


; tratamiento post-call de llamadas Preview transferidas de manera consultativa hacia otro agente
same => n(consultTransfer),Verbose(2, ${CHANNEL} muere en una CT)
same => n,GotoIf($["${SHARED(OMLCALLSTATUS,${CHANNEL})}" == "CT-ACCEPT"]?ctAccept)

same => n,Goto(answer)

same => n(ctAccept),Set(OMLCALLWAITDURATION=${SHARED(OMLCALLTRANSFERWAITDURATION,${OMLMOTHERCHAN})})
same => n,Set(OMLCALLDURATION=$[${EPOCH} - ${SHARED(OMLTRANSFERANSWERTIMESTAMP,${OMLMOTHERCHAN})}])
same => n,Set(OMLAGENTID=${SHARED(OMLAGENTTRANSFERID,${OMLMOTHERCHAN})})
same => n,Set(COMPLETE=COMPLETE-CT)
same => n,AGI(omni-grabaciones.py,${OMLCALLTYPEID},${OMLCAMPID},${OMLOUTNUM},${OMLRECFILENAME},${OMLAGENTID},${OMLCAMPID},${STRFTIME(${EPOCH},,%Y-%m-%d %H:%M:%S)},${OMLUNIQUEID},${OMLCALLDURATION})
same => n,Gosub(sub-oml-queuelog,s,1(${OMLCAMPID},${OMLUNIQUEID},${OMLAGENTID},${COMPLETE},${OMLOUTNUM},${OMLCODCLI},8,${OMLCAMPTYPE},${OMLCALLWAITDURATION},${OMLCALLDURATION},${OMLRECFILENAME},call))
same => n,Gosub(sub-oml-hangup,s,1(NORMAL CLEARING - ${CONTEXT}))


; tratamiento post-call de llamadas Preview transferidas a otra campaña
same => n(campTransfer),GotoIf($["${SHARED(OMLCALLSTATUS,${CHANNEL})}" == "CAMPT-ANSWER"]?camptAnswer)

same => n(campTransferFail),Verbose(2, campTransfer Fail)
same => n,AGI(omni-grabaciones.py,${OMLCALLTYPEID},${OMLCODCLI},${OMLOUTNUM},${OMLRECFILENAME},${OMLAGENTID},${OMLCAMPID},${STRFTIME(${EPOCH},,%Y-%m-%d %H:%M:%S)},${OMLUNIQUEID},${OMLCALLDURATION})
same => n,Gosub(sub-oml-queuelog,s,1(${OMLCAMPID},${OMLUNIQUEID},${OMLAGENTID},CAMPT-FAIL,${OMLOUTNUM},${OMLCODCLI},8,${OMLCAMPTYPE},${OMLCALLWAITDURATION},${OMLCALLDURATION},${OMLRECFILENAME},call))
same => n,GotoIf($["${QUEUESTATUS}" == "TIMEOUT"]?campTransferExpire)
same => n,GotoIf($["${ABANDONED}" == "TRUE"]?campTransferAbandon)

same => n(campTransferExpire),Verbose(2, TIMEOUT queue dialer call)
same => n,Set(OMLCALLWAITDURATION=$[${EPOCH} - ${OMLYEARZEROTRANSFER}])
same => n,Gosub(sub-oml-queuelog,s,1(${OMLCAMPTRANSFERID},${OMLUNIQUEID},,EXITWITHTIMEOUT,${OMLOUTNUM},${OMLCODCLI},8,${OMLCAMPDSTTYPE},${OMLCALLWAITDURATION},,${OMLRECFILENAME},call))
same => n,Gosub(sub-oml-hangup,s,1)

same => n(campTransferAbandon),Verbose(2, ABANDON queue dialer call)
same => n,Set(OMLCALLWAITDURATION=$[${EPOCH} - ${OMLYEARZEROTRANSFER}])
same => n,Gosub(sub-oml-queuelog,s,1(${OMLCAMPTRANSFERID},${OMLUNIQUEID},,ABANDON,${OMLOUTNUM},${OMLCODCLI},8,${OMLCAMPDSTTYPE},${OMLCALLWAITDURATION},,${OMLRECFILENAME},call))
same => n,Gosub(sub-oml-hangup,s,1)

same => n,Gosub(sub-oml-hangup,s,1(NORMAL CLEARING - ${CONTEXT}))

same => n(camptAnswer),Set(OMLCALLDURATION=$[${EPOCH} - ${SHARED(OMLTRANSFERANSWERTIMESTAMP,${OMLMOTHERCHAN})}])
same => n,Set(OMLCALLWAITDURATION=${SHARED(OMLCALLTRANSFERWAITDURATION,${OMLMOTHERCHAN})})
same => n,AGI(omni-grabaciones.py,${OMLCALLTYPEID},${OMLCODCLI},${OMLOUTNUM},${OMLRECFILENAME},${OMLAGENTID},${OMLCAMPID},${STRFTIME(${EPOCH},,%Y-%m-%d %H:%M:%S)},${OMLUNIQUEID},${OMLCALLDURATION})
same => n,Set(__OMLAGENTID=${CUT(MEMBERNAME,_,1)})
same => n,Set(__OMLCAMPIDTRANSFER=${OMLCAMPTRANSFERID})
same => n,Set(__OMLCAMPTYPE=3)

same => n,Set(COMPLETE=COMPLETE-CAMPT)
same => n,Gosub(sub-oml-queuelog,s,1(${OMLCAMPIDTRANSFER},${OMLUNIQUEID},${OMLAGENTID},${COMPLETE},${OMLOUTNUM},${OMLCODCLI},8,${OMLCAMPTYPE},${OMLCALLWAITDURATION},${OMLCALLDURATION},${OMLRECFILENAME},call))
same => n,Gosub(sub-oml-hangup,s,1(NORMAL CLEARING - ${CONTEXT}))


; tratamiento post-call de llamadas Preview transferidas de manera ciega hacia un trunk externo
same => n(blindTransferOutCall),Verbose(2, ${CHANNEL} muere en una BT)
same => n,GotoIf($["${SHARED(OMLCALLSTATUS,${CHANNEL})}" != "BTOUT-ANSWER"]?btOutUnanswer:btOutAnswer)

same => n(btOutUnanswer),Set(OMLCALLWAITDURATION=$[${EPOCH} - ${OMLYEARZEROTRANSFER}])
same => n,ExecIf($["${OMLCALLSTATUS}" == "BTOUT-TRY"]?Set(OMLCALLSTATUS=BTOUT-ABANDON))
same => n,Gosub(sub-oml-queuelog,s,1(${OMLCAMPID},${OMLUNIQUEID},${OMLOUTNUMTRANSFER},${OMLCALLSTATUS},${OMLOUTNUM},${OMLCODCLI},${OMLCALLTYPEID},${OMLCAMPTYPE},${OMLCALLWAITDURATION},${OMLCALLDURATION},${OMLRECFILENAME},call))
same => n,Gosub(sub-oml-hangup,s,1)

same => n(btOutAnswer),Set(OMLCALLWAITDURATION=${SHARED(OMLCALLWAITDURATION,${CHANNEL})})
same => n,Set(OMLCALLDURATION=$[${EPOCH} -  ${SHARED(OMLTRANSFERANSWERTIMESTAMP,${CHANNEL})}])
same => n,AGI(omni-grabaciones.py,${OMLCALLTYPEID},${OMLCODCLI},${OMLOUTNUM},${OMLRECFILENAME},${OMLAGENTID},${OMLCAMPID},${STRFTIME(${EPOCH},,%Y-%m-%d %H:%M:%S)},${OMLUNIQUEID},${OMLCALLDURATION})
same => n,Set(COMPLETE=COMPLETE-BTOUT)
same => n,Gosub(sub-oml-queuelog,s,1(${OMLCAMPID},${OMLUNIQUEID},${OMLOUTNUMTRANSFER},${COMPLETE},${OMLOUTNUM},${OMLCODCLI},9,${OMLCAMPTYPE},${OMLCALLWAITDURATION},${OMLCALLDURATION},${OMLRECFILENAME},call))
same => n,Gosub(sub-oml-hangup,s,1(NORMAL CLEARING - ${CONTEXT}))


; tratamiento post-call de llamadas Preview transferidas de manera consultativa hacia un trunk externo
same => n(consultTransferOutCall),Verbose(2, ${CHANNEL} muere en una CT)
same => n,GotoIf($["${SHARED(OMLCALLSTATUS,${CHANNEL})}" == "CTOUT-ACCEPT"]?ctOutAccept)

same => n,Goto(answer)

same => n(ctOutAccept),Set(OMLCALLWAITDURATION=${SHARED(OMLCALLTRANSFERWAITDURATION,${OMLMOTHERCHAN})})
same => n,Set(OMLCALLDURATION=$[${EPOCH} - ${SHARED(OMLTRANSFERANSWERTIMESTAMP,${OMLMOTHERCHAN})}])
same => n,Set(OMLAGENTID=${SHARED(OMLAGENTTRANSFERID,${OMLMOTHERCHAN})})
same => n,Set(COMPLETE=COMPLETE-CTOUT)
same => n,AGI(omni-grabaciones.py,${OMLCALLTYPEID},${OMLCAMPID},${OMLOUTNUM},${OMLRECFILENAME},${OMLAGENTID},${OMLCAMPID},${STRFTIME(${EPOCH},,%Y-%m-%d %H:%M:%S)},${OMLUNIQUEID},${OMLCALLDURATION})
same => n,Gosub(sub-oml-queuelog,s,1(${OMLCAMPID},${OMLUNIQUEID},${SHARED(OMLOUTNUMTRANSFER,${CHANNEL})},${COMPLETE},${OMLOUTNUM},${OMLCODCLI},9,${OMLCAMPTYPE},${OMLCALLWAITDURATION},${OMLCALLDURATION},${OMLRECFILENAME},call))
same => n,Gosub(sub-oml-hangup,s,1(NORMAL CLEARING - ${CONTEXT}))




; MANUAL CALLS RIP CHANNELS MANUAL CALLS RIP CHANNELS MANUAL CALLS RIP CHANNELS MANUAL CALLS RIP CHANNELS MANUAL CALLS RIP CHANNELS MANUAL CALLS RIP CHANNELS
; MANUAL CALLS RIP CHANNELS MANUAL CALLS RIP CHANNELS MANUAL CALLS RIP CHANNELS MANUAL CALLS RIP CHANNELS MANUAL CALLS RIP CHANNELS MANUAL CALLS RIP CHANNELS
; MANUAL CALLS RIP CHANNELS MANUAL CALLS RIP CHANNELS MANUAL CALLS RIP CHANNELS MANUAL CALLS RIP CHANNELS MANUAL CALLS RIP CHANNELS MANUAL CALLS RIP CHANNELS
; MANUAL CALLS RIP CHANNELS MANUAL CALLS RIP CHANNELS MANUAL CALLS RIP CHANNELS MANUAL CALLS RIP CHANNELS MANUAL CALLS RIP CHANNELS MANUAL CALLS RIP CHANNELS

[rip-manualcall-trunk-chan]
include => rip-manualcall-trunk-chan-custom

exten => s,1,Verbose(2, Manual call hangup handler - TRUNK CHANNEL - SIP/Trunk.... )
same => n,Gosub(sub-oml-hangup,s,1)

[rip-manualcall-agent-chan]
include => rip-manualcall-agent-chan-custom

exten => s,1,Verbose(2, Manual call hangup handler - AGENT CHANNEL )
same => n,Set(DB(OML/AGENT/${OMLAGENTID}/STATUS)=READY:${EPOCH})
same => n,Gosub(sub-oml-hangup,s,1)


[rip-manualcall-originate-dialout-chan]
include => rip-manualcall-originate-dialout-chan-custom

exten => s,1,Verbose(2, As above, So Below - CHANNEL7)
same => n,Verbose(2, OML ----click2call---> DIAL(SIP/trunk/OUTNUM)  | ${GLOBAL(${OMLAGENTSIP}result)})
same => n,Gosub(sub-oml-hangup,s,1(NORMAL CLEARING - ${CONTEXT}))


[rip-manualcall-originate-agent-chan]
; Subrutina de postcall invocada por canales Local/1002@click2call-00000037;2 - Es el canal que dispara el Dial(SIP/1XXX) - AGENT <----- OML en llamadas CLICK2CALL

include => rip-manualcall-originate-agent-chan-custom

exten => s,1,Verbose(2, As above, So Below - CHANNEL8)
same => n,Verbose(2, AGENT <---click2call---- OML  | ${SHARED(OMLCALLSTATUS,${OMLMOTHERCHAN})})

same => n,GotoIf($["${OMLCAMPREC}" != "True"]?checkResult)
same => n,StopMixMonitor(${OMLRECFILENAME}.wav)

same => n(checkResult),Verbose(2, check resultado de llamada DIALSTATUS: ${SHARED(OMLCALLSTATUS,${CHANNEL})} - ${OMLCALLSTATUS})
same => n,GotoIf($["${SHARED(OMLCALLSTATUS,${CHANNEL})}" == "ANSWER"]?answer)
same => n,GotoIf($["${CUT(SHARED(OMLCALLSTATUS,${CHANNEL}),-,1)}" == "BT"]?blindTransfer)
same => n,GotoIf($["${CUT(SHARED(OMLCALLSTATUS,${CHANNEL}),-,1)}" == "CT"]?consultTransfer)
same => n,GotoIf($["${CUT(SHARED(OMLCALLSTATUS,${CHANNEL}),-,1)}" == "CAMPT"]?campTransfer)
same => n,GotoIf($["${CUT(SHARED(OMLCALLSTATUS,${CHANNEL}),-,1)}" == "BTOUT"]?blindTransferOutCall)
same => n,GotoIf($["${CUT(SHARED(OMLCALLSTATUS,${CHANNEL}),-,1)}" == "CTOUT"]?consultTransferOutCall)

same => n,Set(OMLCALLWAITDURATION=$[${EPOCH} - ${OMLYEARZERO}])
same => n,Gosub(sub-oml-queuelog,s,1(${OMLCAMPID},${OMLUNIQUEID},${OMLAGENTID},${SHARED(OMLCALLSTATUS,${CHANNEL})},${OMLOUTNUM},${OMLCODCLI},${OMLCALLTYPEID},${OMLCAMPTYPE},${OMLCALLWAITDURATION},,,call))
same => n,Gosub(sub-oml-hangup,s,1)

same => n(answer),Set(OMLCALLDURATION=$[${EPOCH} - ${SHARED(OMLANSWERTIMESTAMP,${OMLMOTHERCHAN})}])
same => n,Set(OMLCALLWAITDURATION=${SHARED(OMLCALLWAITDURATION,${OMLMOTHERCHAN})})
same => n,ExecIf($["${SHARED(OMLRECFILENAME,${CHANNEL})}" != ""]?Set(OMLRECFILENAME=${SHARED(OMLRECFILENAME,${CHANNEL})}))
same => n,GotoIf($["${OMLRECFILENAME}" == ""]?queueLogManualCall)

same => n,StopMixMonitor(${OMLRECFILENAME}.wav)
same => n,AGI(omni-grabaciones.py,${OMLCALLTYPEID},${OMLCODCLI},${OMLOUTNUM},${OMLRECFILENAME},${OMLAGENTID},${OMLCAMPID},${STRFTIME(${EPOCH},,%Y-%m-%d %H:%M:%S)},${OMLUNIQUEID},${OMLCALLDURATION})

same => n(queueLogManualCall),Verbose(2, hangedup part ${SHARED(OMLSIDEHANGUP,${CHANNEL})})
same => n,ExecIf($["${SHARED(OMLSIDEHANGUP,${CHANNEL})}" == "1"]?Set(COMPLETE=COMPLETEOUTNUM):Set(COMPLETE=COMPLETEAGENT))
same => n,Gosub(sub-oml-queuelog,s,1(${OMLCAMPID},${OMLUNIQUEID},${OMLAGENTID},${COMPLETE},${OMLOUTNUM},${OMLCODCLI},${OMLCALLTYPEID},${OMLCAMPTYPE},${OMLCALLWAITDURATION},${OMLCALLDURATION},${OMLRECFILENAME},call))
same => n,Gosub(sub-oml-hangup,s,1)


; tratamiento post-call de llamadas click2Call transferidas de manera ciega hacia otro agente
same => n(blindTransfer),Verbose(2, ${CHANNEL} muere en una BT)
same => n,GotoIf($["${SHARED(OMLCALLSTATUS,${CHANNEL})}" != "BT-ANSWER"]?btUnanswer:btAnswer)

same => n(btUnanswer),Set(OMLCALLWAITDURATION=$[${EPOCH} - ${OMLYEARZEROTRANSFER}])
same => n,ExecIf($["${OMLCALLSTATUS}" == "BT-TRY"]?Set(OMLCALLSTATUS=BT-ABANDON))
same => n,Gosub(sub-oml-queuelog,s,1(${OMLCAMPID},${OMLUNIQUEID},${OMLAGENTTRANSFERDSTID},${OMLCALLSTATUS},${OMLOUTNUM},${OMLCODCLI},${OMLCALLTYPEID},${OMLCAMPTYPE},${OMLCALLWAITDURATION},${OMLCALLDURATION},${OMLRECFILENAME},call))
same => n,Gosub(sub-oml-hangup,s,1)

same => n(btAnswer),Set(OMLCALLWAITDURATION=${SHARED(OMLCALLWAITDURATION,${CHANNEL})})
same => n,Set(OMLCALLDURATION=$[${EPOCH} -  ${SHARED(OMLTRANSFERANSWERTIMESTAMP,${CHANNEL})}])
same => n,AGI(omni-grabaciones.py,${OMLCALLTYPEID},${OMLCODCLI},${OMLOUTNUM},${OMLRECFILENAME},${OMLAGENTID},${OMLCAMPID},${STRFTIME(${EPOCH},,%Y-%m-%d %H:%M:%S)},${OMLUNIQUEID},${OMLCALLDURATION})
same => n,Set(COMPLETE=COMPLETE-BT)
same => n,Gosub(sub-oml-queuelog,s,1(${OMLCAMPID},${OMLUNIQUEID},${OMLAGENTTRANSFERDSTID},${COMPLETE},${OMLOUTNUM},${OMLCODCLI},8,${OMLCAMPTYPE},${OMLCALLWAITDURATION},${OMLCALLDURATION},${OMLRECFILENAME},call))
same => n,Gosub(sub-oml-hangup,s,1(NORMAL CLEARING - ${CONTEXT}))


; tratamiento post-call de llamadas click2Call transferidas de manera consultativa hacia otro agente
same => n(consultTransfer),Verbose(2, ${CHANNEL} muere en una CT)
same => n,GotoIf($["${SHARED(OMLCALLSTATUS,${CHANNEL})}" == "CT-ACCEPT"]?ctAccept)

same => n,Goto(answer)

same => n(ctAccept),Set(OMLCALLWAITDURATION=${SHARED(OMLCALLTRANSFERWAITDURATION,${OMLMOTHERCHAN})})
same => n,Set(OMLCALLDURATION=$[${EPOCH} - ${SHARED(OMLTRANSFERANSWERTIMESTAMP,${OMLMOTHERCHAN})}])
same => n,Set(OMLAGENTID=${SHARED(OMLAGENTTRANSFERID,${OMLMOTHERCHAN})})
same => n,Set(COMPLETE=COMPLETE-CT)
same => n,AGI(omni-grabaciones.py,${OMLCALLTYPEID},${OMLCAMPID},${OMLOUTNUM},${OMLRECFILENAME},${OMLAGENTID},${OMLCAMPID},${STRFTIME(${EPOCH},,%Y-%m-%d %H:%M:%S)},${OMLUNIQUEID},${OMLCALLDURATION})
same => n,Gosub(sub-oml-queuelog,s,1(${OMLCAMPID},${OMLUNIQUEID},${OMLAGENTID},${COMPLETE},${OMLOUTNUM},${OMLCODCLI},8,${OMLCAMPTYPE},${OMLCALLWAITDURATION},${OMLCALLDURATION},${OMLRECFILENAME},call))
same => n,Gosub(sub-oml-hangup,s,1(NORMAL CLEARING - ${CONTEXT}))


; tratamiento post-call de llamadas click2Call transferidas a otra campaña
same => n(campTransfer),GotoIf($["${SHARED(OMLCALLSTATUS,${CHANNEL})}" == "CAMPT-ANSWER"]?camptAnswer)

same => n(campTransferFail),Verbose(2, campTransfer Fail)
same => n,AGI(omni-grabaciones.py,${OMLCALLTYPEID},${OMLCODCLI},${OMLOUTNUM},${OMLRECFILENAME},${OMLAGENTID},${OMLCAMPID},${STRFTIME(${EPOCH},,%Y-%m-%d %H:%M:%S)},${OMLUNIQUEID},${OMLCALLDURATION})
same => n,Gosub(sub-oml-queuelog,s,1(${OMLCAMPID},${OMLUNIQUEID},${OMLAGENTID},CAMPT-FAIL,${OMLOUTNUM},${OMLCODCLI},8,${OMLCAMPTYPE},${OMLCALLWAITDURATION},${OMLCALLDURATION},${OMLRECFILENAME},call))
same => n,GotoIf($["${QUEUESTATUS}" == "TIMEOUT"]?campTransferExpire)
same => n,GotoIf($["${ABANDONED}" == "TRUE"]?campTransferAbandon)

same => n(campTransferExpire),Verbose(2, TIMEOUT queue dialer call)
same => n,Set(OMLCALLWAITDURATION=$[${EPOCH} - ${OMLYEARZEROTRANSFER}])
same => n,Gosub(sub-oml-queuelog,s,1(${OMLCAMPTRANSFERID},${OMLUNIQUEID},,EXITWITHTIMEOUT,${OMLOUTNUM},${OMLCODCLI},8,${OMLCAMPTYPE},${OMLCALLWAITDURATION},,${OMLRECFILENAME},call))
same => n,Gosub(sub-oml-hangup,s,1)

same => n(campTransferAbandon),Verbose(2, ABANDON queue dialer call)
same => n,Set(OMLCALLWAITDURATION=$[${EPOCH} - ${OMLYEARZEROTRANSFER}])
same => n,Gosub(sub-oml-queuelog,s,1(${OMLCAMPTRANSFERID},${OMLUNIQUEID},,ABANDON,${OMLOUTNUM},${OMLCODCLI},8,${OMLCAMPTYPE},${OMLCALLWAITDURATION},,${OMLRECFILENAME},call))
same => n,Gosub(sub-oml-hangup,s,1)

same => n,Gosub(sub-oml-hangup,s,1(NORMAL CLEARING - ${CONTEXT}))

same => n(camptAnswer),Set(OMLCALLDURATION=$[${EPOCH} - ${SHARED(OMLTRANSFERANSWERTIMESTAMP,${OMLMOTHERCHAN})}])
same => n,Set(OMLCALLWAITDURATION=${SHARED(OMLCALLTRANSFERWAITDURATION,${OMLMOTHERCHAN})})
same => n,AGI(omni-grabaciones.py,${OMLCALLTYPEID},${OMLCODCLI},${OMLOUTNUM},${OMLRECFILENAME},${OMLAGENTID},${OMLCAMPID},${STRFTIME(${EPOCH},,%Y-%m-%d %H:%M:%S)},${OMLUNIQUEID},${OMLCALLDURATION})
same => n,Set(__OMLAGENTID=${CUT(MEMBERNAME,_,1)})
same => n,Set(__OMLCAMPIDTRANSFER=${OMLCAMPTRANSFERID})
same => n,Set(__OMLCAMPTYPE=3)

same => n,Set(COMPLETE=COMPLETE-CAMPT)
same => n,Gosub(sub-oml-queuelog,s,1(${OMLCAMPIDTRANSFER},${OMLUNIQUEID},${OMLAGENTID},${COMPLETE},${OMLOUTNUM},${OMLCODCLI},8,${OMLCAMPTYPE},${OMLCALLWAITDURATION},${OMLCALLDURATION},${OMLRECFILENAME},call))
same => n,Gosub(sub-oml-hangup,s,1(NORMAL CLEARING - ${CONTEXT}))


; tratamiento post-call de llamadas click2Call transferidas de manera ciega hacia un trunk externo
same => n(blindTransferOutCall),Verbose(2, ${CHANNEL} muere en una BT)
same => n,GotoIf($["${SHARED(OMLCALLSTATUS,${CHANNEL})}" != "BTOUT-ANSWER"]?btOutUnanswer:btOutAnswer)

same => n(btOutUnanswer),Set(OMLCALLWAITDURATION=$[${EPOCH} - ${OMLYEARZEROTRANSFER}])
same => n,ExecIf($["${OMLCALLSTATUS}" == "BTOUT-TRY"]?Set(OMLCALLSTATUS=BTOUT-ABANDON))
same => n,Gosub(sub-oml-queuelog,s,1(${OMLCAMPID},${OMLUNIQUEID},${OMLOUTNUMTRANSFER},${OMLCALLSTATUS},${OMLOUTNUM},${OMLCODCLI},${OMLCALLTYPEID},${OMLCAMPTYPE},${OMLCALLWAITDURATION},${OMLCALLDURATION},${OMLRECFILENAME},call))
same => n,Gosub(sub-oml-hangup,s,1)

same => n(btOutAnswer),Set(OMLCALLWAITDURATION=${SHARED(OMLCALLWAITDURATION,${CHANNEL})})
same => n,Set(OMLCALLDURATION=$[${EPOCH} -  ${SHARED(OMLTRANSFERANSWERTIMESTAMP,${CHANNEL})}])
same => n,AGI(omni-grabaciones.py,${OMLCALLTYPEID},${OMLCODCLI},${OMLOUTNUM},${OMLRECFILENAME},${OMLAGENTID},${OMLCAMPID},${STRFTIME(${EPOCH},,%Y-%m-%d %H:%M:%S)},${OMLUNIQUEID},${OMLCALLDURATION})
same => n,Set(COMPLETE=COMPLETE-BTOUT)
same => n,Gosub(sub-oml-queuelog,s,1(${OMLCAMPID},${OMLUNIQUEID},${OMLOUTNUMTRANSFER},${COMPLETE},${OMLOUTNUM},${OMLCODCLI},9,${OMLCAMPTYPE},${OMLCALLWAITDURATION},${OMLCALLDURATION},${OMLRECFILENAME},call))
same => n,Gosub(sub-oml-hangup,s,1(NORMAL CLEARING - ${CONTEXT}))


; tratamiento post-call de llamadas click2Call transferidas de manera consultativa hacia un trunk externo
same => n(consultTransferOutCall),Verbose(2, ${CHANNEL} muere en una CT)
same => n,GotoIf($["${SHARED(OMLCALLSTATUS,${CHANNEL})}" == "CTOUT-ACCEPT"]?ctOutAccept)

same => n,Goto(answer)

same => n(ctOutAccept),Set(OMLCALLWAITDURATION=${SHARED(OMLCALLTRANSFERWAITDURATION,${OMLMOTHERCHAN})})
same => n,Set(OMLCALLDURATION=$[${EPOCH} - ${SHARED(OMLTRANSFERANSWERTIMESTAMP,${OMLMOTHERCHAN})}])
same => n,Set(OMLAGENTID=${SHARED(OMLAGENTTRANSFERID,${OMLMOTHERCHAN})})
same => n,Set(COMPLETE=COMPLETE-CTOUT)
same => n,AGI(omni-grabaciones.py,${OMLCALLTYPEID},${OMLCAMPID},${OMLOUTNUM},${OMLRECFILENAME},${OMLAGENTID},${OMLCAMPID},${STRFTIME(${EPOCH},,%Y-%m-%d %H:%M:%S)},${OMLUNIQUEID},${OMLCALLDURATION})
same => n,Gosub(sub-oml-queuelog,s,1(${OMLCAMPID},${OMLUNIQUEID},${SHARED(OMLOUTNUMTRANSFER,${CHANNEL})},${COMPLETE},${OMLOUTNUM},${OMLCODCLI},9,${OMLCAMPTYPE},${OMLCALLWAITDURATION},${OMLCALLDURATION},${OMLRECFILENAME},call))
same => n,Gosub(sub-oml-hangup,s,1(NORMAL CLEARING - ${CONTEXT}))

; WITHOUTCAMP CALLS RIP CHANNELS WITHOUTCAMP CALLS RIP CHANNELS WITHOUTCAMP CALLS RIP CHANNELS WITHOUTCAMP CALLS RIP CHANNELS WITHOUTCAMP CALLS RIP CHANNELS
; WITHOUTCAMP CALLS RIP CHANNELS WITHOUTCAMP CALLS RIP CHANNELS WITHOUTCAMP CALLS RIP CHANNELS WITHOUTCAMP CALLS RIP CHANNELS WITHOUTCAMP CALLS RIP CHANNELS
; WITHOUTCAMP CALLS RIP CHANNELS WITHOUTCAMP CALLS RIP CHANNELS WITHOUTCAMP CALLS RIP CHANNELS WITHOUTCAMP CALLS RIP CHANNELS WITHOUTCAMP CALLS RIP CHANNELS
; WITHOUTCAMP CALLS RIP CHANNELS WITHOUTCAMP CALLS RIP CHANNELS WITHOUTCAMP CALLS RIP CHANNELS WITHOUTCAMP CALLS RIP CHANNELS WITHOUTCAMP CALLS RIP CHANNELS

[rip-withoutcamp-trunk-chan]
include => rip-withoutcamp-trunk-chan-custom

exten => s,1,Verbose(2, Manual call hangup handler - TRUNK CHANNEL - SIP/Trunk.... )
same => n,Gosub(sub-oml-hangup,s,1)

[rip-withoutcamp-agent-chan]
include => rip-withoutcamp-agent-chan-custom

exten => s,1,Verbose(2, Manual call hangup handler - AGENT CHANNEL )
same => n,Set(DB(OML/AGENT/${OMLAGENTID}/STATUS)=READY:${EPOCH})
same => n,Gosub(sub-oml-hangup,s,1)


[rip-withoutcamp-originate-dialout-chan]
include => rip-withoutcamp-originate-dialout-chan-custom

exten => s,1,Verbose(2, As above, So Below - CHANNEL7)
same => n,Verbose(2, OML ----click2call---> DIAL(SIP/trunk/OUTNUM)  | ${GLOBAL(${OMLAGENTSIP}result)})
same => n,Gosub(sub-oml-hangup,s,1(NORMAL CLEARING - ${CONTEXT}))


[rip-withoutcamp-originate-agent-chan]
; Subrutina de postcall invocada por canales Local/1002@click2call-00000037;2 - Es el canal que dispara el Dial(SIP/1XXX) - AGENT <----- OML en llamadas CLICK2CALL

include => rip-withoutcamp-originate-agent-chan-custom

exten => s,1,Verbose(2, As above, So Below - CHANNEL8)
same => n,Verbose(2, AGENT <---click2call---- OML  | ${SHARED(OMLCALLSTATUS,${OMLMOTHERCHAN})})

same => n,GotoIf($["${OMLCAMPREC}" != "True"]?checkResult)
same => n,StopMixMonitor(${OMLRECFILENAME}.wav)

same => n(checkResult),Verbose(2, check resultado de llamada DIALSTATUS: ${SHARED(OMLCALLSTATUS,${CHANNEL})} - ${OMLCALLSTATUS})
same => n,GotoIf($["${SHARED(OMLCALLSTATUS,${CHANNEL})}" == "ANSWER"]?answer)

same => n,Set(OMLCALLWAITDURATION=$[${EPOCH} - ${OMLYEARZERO}])
;same => n,Gosub(sub-oml-queuelog,s,1(0,${OMLUNIQUEID},${OMLAGENTID},${SHARED(OMLCALLSTATUS,${CHANNEL})},${OMLOUTNUM},${OMLCODCLI},7,${OMLCAMPTYPE},${OMLCALLWAITDURATION},,,call))
same => n,Gosub(sub-oml-hangup,s,1)

same => n(answer),Set(OMLCALLDURATION=$[${EPOCH} - ${SHARED(OMLANSWERTIMESTAMP,${OMLMOTHERCHAN})}])
same => n,Set(OMLCALLWAITDURATION=${SHARED(OMLCALLWAITDURATION,${OMLMOTHERCHAN})})
same => n,Verbose(2, hangedup part ${SHARED(OMLSIDEHANGUP,${CHANNEL})})
same => n,ExecIf($["${SHARED(OMLSIDEHANGUP,${CHANNEL})}" == "1"]?Set(COMPLETE=COMPLETEOUTNUM):Set(COMPLETE=COMPLETEAGENT))
;same => n,Gosub(sub-oml-queuelog,s,1(0,${OMLUNIQUEID},${OMLAGENTID},${COMPLETE},${OMLOUTNUM},${OMLCODCLI},7,${OMLCAMPTYPE},${OMLCALLWAITDURATION},${OMLCALLDURATION},${OMLRECFILENAME},call))
same => n,Gosub(sub-oml-hangup,s,1)



; INBOUND CALLS RIP CHANNELS INBOUND CALLS RIP CHANNELSINBOUND CALLS RIP CHANNELSINBOUND CALLS RIP CHANNELS INBOUND CALLS RIP CHANNELS INBOUND CALLS RIP CHANNELS
; INBOUND CALLS RIP CHANNELS INBOUND CALLS RIP CHANNELSINBOUND CALLS RIP CHANNELSINBOUND CALLS RIP CHANNELS INBOUND CALLS RIP CHANNELS INBOUND CALLS RIP CHANNELS
; INBOUND CALLS RIP CHANNELS INBOUND CALLS RIP CHANNELSINBOUND CALLS RIP CHANNELSINBOUND CALLS RIP CHANNELS INBOUND CALLS RIP CHANNELS INBOUND CALLS RIP CHANNELS
; INBOUND CALLS RIP CHANNELS INBOUND CALLS RIP CHANNELSINBOUND CALLS RIP CHANNELSINBOUND CALLS RIP CHANNELS INBOUND CALLS RIP CHANNELS INBOUND CALLS RIP CHANNELS

[rip-in-trunk-chan]
include => rip-in-trunk-chan-custom

exten => s,1,Verbose(2, Trunk chan postcall inboundCall -  ${SHARED(OMLCALLSTATUS,${CHANNEL})})
same => n,StopMixMonitor(${OMLRECFILENAME}.wav)
same => n,GotoIf($["${CUT(SHARED(OMLCALLSTATUS,${CHANNEL}),-,1)}" == "BT"]?blindTransfer)
same => n,GotoIf($["${CUT(SHARED(OMLCALLSTATUS,${CHANNEL}),-,1)}" == "CT"]?consultTransfer)
same => n,GotoIf($["${CUT(SHARED(OMLCALLSTATUS,${CHANNEL}),-,1)}" == "CAMPT"]?campTransfer)
same => n,GotoIf($["${CUT(SHARED(OMLCALLSTATUS,${CHANNEL}),-,1)}" == "BTOUT"]?blindTransferOutCall)
same => n,GotoIf($["${CUT(SHARED(OMLCALLSTATUS,${CHANNEL}),-,1)}" == "CTOUT"]?consultTransferOutCall)
same => n,GotoIf($["${QUEUESTATUS}" == "TIMEOUT" && "${OMLFAILOVER}" != "true"]?inboundExpire)
same => n,GotoIf($["${QUEUESTATUS}" == "FULL"]?inboundFull)
same => n,GotoIf($["${ABANDONED}" == "TRUE"]?inboundAbandon)
same => n,GotoIf($["${OMLFAILOVER}" == "true" && "${SHARED(OMLFAILOVER,${OMLMOTHERCHAN})}" != "trueandconnect"]?failoverMotherQueue)
same => n,GotoIf($["${SHARED(OMLANSWERTIMESTAMP,${CHANNEL})}" != ""]?inboundAttend:inboundAbandonWel)

; la llamada inbound expiro
same => n(inboundExpire),Verbose(2, TIMEOUT queue inbound call)
same => n,Set(OMLCALLWAITDURATION=$[${EPOCH} - ${OMLYEARZERO}])
same => n,Gosub(sub-oml-queuelog,s,1(${OMLCAMPID},${OMLUNIQUEID},${OMLAGENTID},EXITWITHTIMEOUT,${OMLOUTNUM},${OMLCODCLI},${OMLCALLTYPEID},${OMLCAMPTYPE},${OMLCALLWAITDURATION},${OMLCALLDURATION},,call))
same => n,Gosub(sub-oml-hangup,s,1)

; la llamada inbound expiro y ya venia de un failoverCall
same => n(failoverMotherQueue),Verbose(2, the end of failover queue call)
same => n,Verbose(2, type of FAILOVER: ${FAILOVERCLASS})
;same => n,Gosub(sub-oml-queuelog,s,1(${OMLCAMPID},${OMLUNIQUEID},${OMLAGENTID},EXITWITHTIMEOUT,${OMLOUTNUM},${OMLCODCLI},${OMLCALLTYPEID},${OMLCAMPTYPE},${OMLCALLWAITDURATION},${OMLCALLDURATION},,call))
same => n,Gosub(sub-oml-hangup,s,1)

; la llamada inbound fue un abandono
same => n(inboundAbandon),Verbose(2, ABANDON queue inbound call)
same => n,Set(OMLCALLWAITDURATION=$[${EPOCH} - ${OMLYEARZERO}])
same => n,Gosub(sub-oml-queuelog,s,1(${OMLCAMPID},${OMLUNIQUEID},${OMLAGENTID},ABANDON,${OMLOUTNUM},${OMLCODCLI},${OMLCALLTYPEID},${OMLCAMPTYPE},${OMLCALLWAITDURATION},${OMLCALLDURATION},,call))
same => n,Gosub(sub-oml-hangup,s,1(NORMAL CLEARING: inboundAbandon Call))

; la llamada inbound fue un abandono durante welcome message
same => n(inboundAbandonWel),Verbose(2, ABANDONWEL queue inbound call)
same => n,Set(OMLCALLWAITDURATION=$[${EPOCH} - ${OMLYEARZERO}])
same => n,Gosub(sub-oml-queuelog,s,1(${OMLCAMPID},${OMLUNIQUEID},${OMLAGENTID},ABANDONWEL,${OMLOUTNUM},${OMLCODCLI},${OMLCALLTYPEID},${OMLCAMPTYPE},${OMLCALLWAITDURATION},${OMLCALLDURATION},,call))
same => n,Gosub(sub-oml-hangup,s,1(NORMAL CLEARING: inboundAbandon Call))

; la llamada inbound fue descartada por exceder la cantidad de llamadas en cola
same => n(inboundFull),Verbose(2, FULL queue inbound call)
same => n,Gosub(sub-oml-queuelog,s,1(${OMLCAMPID},${OMLUNIQUEID},${OMLAGENTID},EXITWITHTIMEOUT,${OMLOUTNUM},${OMLCODCLI},${OMLCALLTYPEID},${OMLCAMPTYPE},${OMLCALLWAITDURATION},${OMLCALLDURATION},,call))
same => n,Gosub(sub-oml-hangup,s,1(NORMAL CLEARING: inboundAbandon Call))

; la llamada inbound fue atendida por un agente
same => n(inboundAttend),Verbose(2, inbound attend)
same => n,Set(OMLCALLWAITDURATION=${SHARED(OMLCALLWAITDURATION,${CHANNEL})})
same => n,Set(OMLCALLDURATION=$[${EPOCH} - ${SHARED(OMLANSWERTIMESTAMP,${CHANNEL})}])
same => n,ExecIf($["${SHARED(OMLRECFILENAME,${CHANNEL})}" != ""]?Set(OMLRECFILENAME=${SHARED(OMLRECFILENAME,${CHANNEL})}))
same => n,GotoIf($["${OMLRECFILENAME}" == ""]?queueLog)

same => n,StopMixMonitor(${OMLRECFILENAME}.wav)
same => n,AGI(omni-grabaciones.py,${OMLCALLTYPEID},${OMLCODCLI},${OMLOUTNUM},${OMLRECFILENAME},${SHARED(OMLAGENTID,${CHANNEL})},${OMLCAMPID},${STRFTIME(${EPOCH},,%Y-%m-%d %H:%M:%S)},${OMLUNIQUEID},${OMLCALLDURATION})

same => n(queueLog),Set(OMLAGENTID=${CUT(MEMBERNAME,_,1)})
same => n,Verbose(2, hangedup part ${OMLSIDEHANGUP})
same => n,ExecIf($["${OMLSIDEHANGUP}" == "2"]?Set(COMPLETE=COMPLETEAGENT):Set(COMPLETE=COMPLETEOUTNUM))
same => n,Gosub(sub-oml-queuelog,s,1(${OMLCAMPID},${OMLUNIQUEID},${OMLAGENTID},${COMPLETE},${OMLOUTNUM},${OMLCODCLI},${OMLCALLTYPEID},${OMLCAMPTYPE},${OMLCALLWAITDURATION},${OMLCALLDURATION},${OMLRECFILENAME},call))
same => n,Gosub(sub-oml-hangup,s,1)

; transferencias transferencias inbound
; tratamiento post-call de llamadas Inbound transferidas de manera ciega hacia otro agente
same => n(blindTransfer),Verbose(2, ${CHANNEL} muere en una BT)
same => n,GotoIf($["${SHARED(OMLCALLSTATUS,${CHANNEL})}" != "BT-ANSWER"]?btUnanswer:btAnswer)

same => n(btUnanswer),Set(OMLCALLWAITDURATION=$[${EPOCH} - ${OMLYEARZEROTRANSFER}])
same => n,ExecIf($["${OMLCALLSTATUS}" == "BT-TRY"]?Set(OMLCALLSTATUS=BT-ABANDON))
same => n,Gosub(sub-oml-queuelog,s,1(${OMLCAMPID},${OMLUNIQUEID},${OMLAGENTTRANSFERDSTID},${OMLCALLSTATUS},${OMLOUTNUM},${OMLCODCLI},${OMLCALLTYPEID},${OMLCAMPTYPE},${OMLCALLWAITDURATION},${OMLCALLDURATION},${OMLRECFILENAME},call))
same => n,Gosub(sub-oml-hangup,s,1)

same => n(btAnswer),Set(OMLCALLWAITDURATION=${SHARED(OMLCALLWAITDURATION,${CHANNEL})})
same => n,Set(OMLCALLDURATION=$[${EPOCH} -  ${SHARED(OMLTRANSFERANSWERTIMESTAMP,${CHANNEL})}])
same => n,AGI(omni-grabaciones.py,${OMLCALLTYPEID},${OMLCODCLI},${OMLOUTNUM},${OMLRECFILENAME},${OMLAGENTID},${OMLCAMPID},${STRFTIME(${EPOCH},,%Y-%m-%d %H:%M:%S)},${OMLUNIQUEID},${OMLCALLDURATION})
same => n,Set(COMPLETE=COMPLETE-BT)
same => n,Gosub(sub-oml-queuelog,s,1(${OMLCAMPID},${OMLUNIQUEID},${OMLAGENTTRANSFERDSTID},${COMPLETE},${OMLOUTNUM},${OMLCODCLI},8,${OMLCAMPTYPE},${OMLCALLWAITDURATION},${OMLCALLDURATION},${OMLRECFILENAME},call))
same => n,Gosub(sub-oml-hangup,s,1(NORMAL CLEARING - ${CONTEXT}))


; tratamiento post-call de llamadas Inbound transferidas de manera consultativa hacia otro agente
same => n(consultTransfer),Verbose(2, ${CHANNEL} muere en una CT)
same => n,GotoIf($["${SHARED(OMLCALLSTATUS,${CHANNEL})}" == "CT-ACCEPT"]?ctAccept)
same => n,GotoIf($["${CHANNELS(${SHARED(OMLAGENTSIPTRANSFERDST,${OMLMOTHERCHAN})})}"  != "" && "${CHANNELS(${MEMBERINTERFACE})}"  != ""]?ctAbandon)

same => n,Goto(inboundAttend)

same => n(ctAccept),Set(OMLCALLWAITDURATION=${SHARED(OMLCALLTRANSFERWAITDURATION,${OMLMOTHERCHAN})})
same => n,Set(OMLCALLDURATION=$[${EPOCH} - ${SHARED(OMLTRANSFERANSWERTIMESTAMP,${OMLMOTHERCHAN})}])
same => n,Set(COMPLETE=COMPLETE-CT)
same => n,AGI(omni-grabaciones.py,${OMLCALLTYPEID},${OMLCAMPID},${OMLOUTNUM},${OMLRECFILENAME},${OMLAGENTID},${OMLCAMPID},${STRFTIME(${EPOCH},,%Y-%m-%d %H:%M:%S)},${OMLUNIQUEID},${OMLCALLDURATION})
same => n,Gosub(sub-oml-queuelog,s,1(${OMLCAMPID},${OMLUNIQUEID},${SHARED(OMLAGENTTRANSFERDSTID,${OMLMOTHERCHAN})},${COMPLETE},${OMLOUTNUM},${OMLCODCLI},8,${OMLCAMPTYPE},${OMLCALLWAITDURATION},${OMLCALLDURATION},${OMLRECFILENAME},call))
same => n,Gosub(sub-oml-hangup,s,1(NORMAL CLEARING - ${CONTEXT}))

same => n(ctAbandon),Set(OMLCALLWAITDURATION=${SHARED(OMLCALLTRANSFERWAITDURATION,${OMLMOTHERCHAN})})
same => n,AGI(omni-grabaciones.py,${OMLCALLTYPEID},${OMLCAMPID},${OMLOUTNUM},${OMLRECFILENAME},${OMLAGENTID},${OMLCAMPID},${STRFTIME(${EPOCH},,%Y-%m-%d %H:%M:%S)},${OMLUNIQUEID},${OMLCALLDURATION})
same => n,Gosub(sub-oml-queuelog,s,1(${OMLCAMPID},${OMLUNIQUEID},${SHARED(OMLAGENTTRANSFERDSTID,${OMLMOTHERCHAN})},CT-ABANDON,${OMLOUTNUM},${OMLCODCLI},8,${OMLCAMPTYPE},${OMLCALLWAITDURATION},${OMLCALLDURATION},${OMLRECFILENAME},call))
same => n,Gosub(sub-oml-queuelog,s,1(${OMLCAMPID},${OMLUNIQUEID},${SHARED(OMLAGENTID,${OMLMOTHERCHAN})},ABANDON-CT,${OMLOUTNUM},${OMLCODCLI},8,${OMLCAMPTYPE},${OMLCALLWAITDURATION},${OMLCALLDURATION},${OMLRECFILENAME},call))
same => n,Gosub(sub-oml-hangup,s,1(NORMAL CLEARING - ${CONTEXT}))


; tratamiento post-call de llamadas Inbound transferidas a otra campaña
same => n(campTransfer),GotoIf($["${SHARED(OMLCALLSTATUS,${CHANNEL})}" == "CAMPT-ANSWER"]?camptAnswer)

same => n(campTransferFail),Verbose(2, campTransfer Fail)
same => n,AGI(omni-grabaciones.py,${OMLCALLTYPEID},${OMLCODCLI},${OMLOUTNUM},${OMLRECFILENAME},${OMLAGENTID},${OMLCAMPID},${STRFTIME(${EPOCH},,%Y-%m-%d %H:%M:%S)},${OMLUNIQUEID},${OMLCALLDURATION})
same => n,Gosub(sub-oml-queuelog,s,1(${OMLCAMPID},${OMLUNIQUEID},${OMLAGENTID},CAMPT-FAIL,${OMLOUTNUM},${OMLCODCLI},8,${OMLCAMPTYPE},${OMLCALLWAITDURATION},${OMLCALLDURATION},${OMLRECFILENAME},call))
same => n,GotoIf($["${QUEUESTATUS}" == "TIMEOUT"]?campTransferExpire)
same => n,GotoIf($["${QUEUESTATUS}" == "FULL"]?campTransferFull)
same => n,GotoIf($["${ABANDONED}" == "TRUE"]?campTransferAbandon)

same => n(campTransferExpire),Verbose(2, TIMEOUT queue inbound call)
same => n,Set(OMLCALLWAITDURATION=$[${EPOCH} - ${OMLYEARZEROTRANSFER}])
same => n,Gosub(sub-oml-queuelog,s,1(${OMLCAMPTRANSFERID},${OMLUNIQUEID},,EXITWITHTIMEOUT,${OMLOUTNUM},${OMLCODCLI},8,${OMLCAMPDSTTYPE},${OMLCALLWAITDURATION},,${OMLRECFILENAME},call))
same => n,Gosub(sub-oml-hangup,s,1)

same => n(campTransferFull),Verbose(2, FULL queue inbound call)
same => n,Set(OMLCALLWAITDURATION=$[${EPOCH} - ${OMLYEARZEROTRANSFER}])
same => n,Gosub(sub-oml-queuelog,s,1(${OMLCAMPTRANSFERID},${OMLUNIQUEID},,EXITWITHTIMEOUT,${OMLOUTNUM},${OMLCODCLI},8,${OMLCAMPDSTTYPE},${OMLCALLWAITDURATION},,${OMLRECFILENAME},call))
same => n,Gosub(sub-oml-hangup,s,1)

same => n(campTransferAbandon),Verbose(2, ABANDON queue dialer call)
same => n,Set(OMLCALLWAITDURATION=$[${EPOCH} - ${OMLYEARZEROTRANSFER}])
same => n,Gosub(sub-oml-queuelog,s,1(${OMLCAMPTRANSFERID},${OMLUNIQUEID},,ABANDON,${OMLOUTNUM},${OMLCODCLI},8,${OMLCAMPDSTTYPE},${OMLCALLWAITDURATION},,${OMLRECFILENAME},call))
same => n,Gosub(sub-oml-hangup,s,1)

same => n,Gosub(sub-oml-hangup,s,1(NORMAL CLEARING - ${CONTEXT}))

same => n(camptAnswer),Set(OMLCALLDURATION=$[${EPOCH} - ${SHARED(OMLTRANSFERANSWERTIMESTAMP,${OMLMOTHERCHAN})}])
same => n,Set(OMLCALLWAITDURATION=${SHARED(OMLCALLTRANSFERWAITDURATION,${OMLMOTHERCHAN})})
same => n,AGI(omni-grabaciones.py,${OMLCALLTYPEID},${OMLCODCLI},${OMLOUTNUM},${OMLRECFILENAME},${OMLAGENTID},${OMLCAMPID},${STRFTIME(${EPOCH},,%Y-%m-%d %H:%M:%S)},${OMLUNIQUEID},${OMLCALLDURATION})
same => n,Set(__OMLAGENTID=${CUT(MEMBERNAME,_,1)})
same => n,Set(__OMLCAMPIDTRANSFER=${OMLCAMPTRANSFERID})
same => n,Set(__OMLCAMPTYPE=3)

same => n,Set(COMPLETE=COMPLETE-CAMPT)
same => n,Gosub(sub-oml-queuelog,s,1(${OMLCAMPIDTRANSFER},${OMLUNIQUEID},${OMLAGENTID},${COMPLETE},${OMLOUTNUM},${OMLCODCLI},8,${OMLCAMPTYPE},${OMLCALLWAITDURATION},${OMLCALLDURATION},${OMLRECFILENAME},call))
same => n,Gosub(sub-oml-hangup,s,1(NORMAL CLEARING - ${CONTEXT}))

; tratamiento post-call de llamadas Inbound transferidas de manera ciega hacia un trunk externo
same => n(blindTransferOutCall),Verbose(2, ${CHANNEL} muere en una BT)
same => n,GotoIf($["${SHARED(OMLCALLSTATUS,${CHANNEL})}" != "BTOUT-ANSWER"]?btOutUnanswer:btOutAnswer)

same => n(btOutUnanswer),Set(OMLCALLWAITDURATION=$[${EPOCH} - ${OMLYEARZEROTRANSFER}])
same => n,ExecIf($["${OMLCALLSTATUS}" == "BTOUT-TRY"]?Set(OMLCALLSTATUS=BTOUT-ABANDON))
same => n,Gosub(sub-oml-queuelog,s,1(${OMLCAMPID},${OMLUNIQUEID},${OMLOUTNUMTRANSFER},${OMLCALLSTATUS},${OMLOUTNUM},${OMLCODCLI},${OMLCALLTYPEID},${OMLCAMPTYPE},${OMLCALLWAITDURATION},${OMLCALLDURATION},${OMLRECFILENAME},call))
same => n,Gosub(sub-oml-hangup,s,1)

same => n(btOutAnswer),Set(OMLCALLWAITDURATION=${SHARED(OMLCALLWAITDURATION,${CHANNEL})})
same => n,Set(OMLCALLDURATION=$[${EPOCH} -  ${SHARED(OMLTRANSFERANSWERTIMESTAMP,${CHANNEL})}])
same => n,AGI(omni-grabaciones.py,${OMLCALLTYPEID},${OMLCODCLI},${OMLOUTNUM},${OMLRECFILENAME},${OMLAGENTID},${OMLCAMPID},${STRFTIME(${EPOCH},,%Y-%m-%d %H:%M:%S)},${OMLUNIQUEID},${OMLCALLDURATION})
same => n,Set(COMPLETE=COMPLETE-BTOUT)
same => n,Gosub(sub-oml-queuelog,s,1(${OMLCAMPID},${OMLUNIQUEID},${OMLOUTNUMTRANSFER},${COMPLETE},${OMLOUTNUM},${OMLCODCLI},9,${OMLCAMPTYPE},${OMLCALLWAITDURATION},${OMLCALLDURATION},${OMLRECFILENAME},call))
same => n,Gosub(sub-oml-hangup,s,1(NORMAL CLEARING - ${CONTEXT}))


; tratamiento post-call de llamadas Inbound transferidas de manera consultativa hacia un trunk externo
same => n(consultTransferOutCall),Verbose(2, ${CHANNEL} muere en una CT)
same => n,GotoIf($["${SHARED(OMLCALLSTATUS,${CHANNEL})}" == "CTOUT-ACCEPT"]?ctOutAccept)
same => n,GotoIf($["${CHANNELS(${SHARED(OMLOUTNUMTRANSFER,${OMLMOTHERCHAN})})}"  != "" && "${CHANNELS(${MEMBERINTERFACE})}"  != ""]?ctOutAbandon)

same => n,Goto(inboundAttend)

same => n(ctOutAccept),Set(OMLCALLWAITDURATION=${SHARED(OMLCALLTRANSFERWAITDURATION,${OMLMOTHERCHAN})})
same => n,Set(OMLCALLDURATION=$[${EPOCH} - ${SHARED(OMLTRANSFERANSWERTIMESTAMP,${OMLMOTHERCHAN})}])
same => n,Set(OMLAGENTID=${SHARED(OMLAGENTTRANSFERID,${OMLMOTHERCHAN})})
same => n,Set(COMPLETE=COMPLETE-CTOUT)
same => n,AGI(omni-grabaciones.py,${OMLCALLTYPEID},${OMLCAMPID},${OMLOUTNUM},${OMLRECFILENAME},${OMLAGENTID},${OMLCAMPID},${STRFTIME(${EPOCH},,%Y-%m-%d %H:%M:%S)},${OMLUNIQUEID},${OMLCALLDURATION})
same => n,Gosub(sub-oml-queuelog,s,1(${OMLCAMPID},${OMLUNIQUEID},${SHARED(OMLOUTNUMTRANSFER,${CHANNEL})},${COMPLETE},${OMLOUTNUM},${OMLCODCLI},9,${OMLCAMPTYPE},${OMLCALLWAITDURATION},${OMLCALLDURATION},${OMLRECFILENAME},call))
same => n,Gosub(sub-oml-hangup,s,1(NORMAL CLEARING - ${CONTEXT}))

same => n(ctOutAbandon),Set(OMLCALLWAITDURATION=${SHARED(OMLCALLTRANSFERWAITDURATION,${OMLMOTHERCHAN})})
same => n,AGI(omni-grabaciones.py,${OMLCALLTYPEID},${OMLCAMPID},${OMLOUTNUM},${OMLRECFILENAME},${OMLAGENTID},${OMLCAMPID},${STRFTIME(${EPOCH},,%Y-%m-%d %H:%M:%S)},${OMLUNIQUEID},${OMLCALLDURATION})
same => n,Gosub(sub-oml-queuelog,s,1(${OMLCAMPID},${OMLUNIQUEID},${SHARED(OMLOUTNUMTRANSFER,${OMLMOTHERCHAN})},CTOUT-ABANDON,${OMLOUTNUM},${OMLCODCLI},8,${OMLCAMPTYPE},${OMLCALLWAITDURATION},${OMLCALLDURATION},${OMLRECFILENAME},call))
same => n,Gosub(sub-oml-queuelog,s,1(${OMLCAMPID},${OMLUNIQUEID},${SHARED(OMLAGENTID,${OMLMOTHERCHAN})},ABANDON-CTOUT,${OMLOUTNUM},${OMLCODCLI},8,${OMLCAMPTYPE},${OMLCALLWAITDURATION},${OMLCALLDURATION},${OMLRECFILENAME},call))
same => n,Gosub(sub-oml-hangup,s,1(NORMAL CLEARING - ${CONTEXT}))

[rip-in-agent-chan]
; en las inbound call, CHANNEL-2 actualiza el status del agente que atendio la llamada y nada más, salvo que ....
include => rip-in-agent-chan-custom

exten => s,1,Verbose(2, RIP inbound agent channel)
same => n,Set(DB(OML/AGENT/${OMLAGENTID}/STATUS)=READY:${EPOCH})
same => n,Hangup()




; DIALER CALLS RIP CHANNELS DIALER CALLS RIP CHANNELS DIALER CALLS RIP CHANNELS DIALER CALLS RIP CHANNELS DIALER CALLS RIP CHANNELS DIALER CALLS RIP CHANNELS
; DIALER CALLS RIP CHANNELS DIALER CALLS RIP CHANNELS DIALER CALLS RIP CHANNELS DIALER CALLS RIP CHANNELS DIALER CALLS RIP CHANNELS DIALER CALLS RIP CHANNELS
; DIALER CALLS RIP CHANNELS DIALER CALLS RIP CHANNELS DIALER CALLS RIP CHANNELS DIALER CALLS RIP CHANNELS DIALER CALLS RIP CHANNELS DIALER CALLS RIP CHANNELS
; DIALER CALLS RIP CHANNELS DIALER CALLS RIP CHANNELS DIALER CALLS RIP CHANNELS DIALER CALLS RIP CHANNELS DIALER CALLS RIP CHANNELS DIALER CALLS RIP CHANNELS


[rip-dialer-originate-dial-outnum-chan]
; Subrutina de postcall invocada por canales Local/XXXX.......;2 (WD Originate Channel) - OML ---> Dial(SIP/trunk/XXXXXXX)
; Por ahora solo tiene sentido en dialer ya que estos canales solamente serian generados en ese escenario
include => rip-dialer-originate-dial-outnum-chan-custom

exten => s,1,Verbose(2, As above, So Below - CHANNEL3)
same => n,Verbose(2, CDR(duration): ${CDR(duration)} - CDR(billsec): ${CDR(billsec)} - ${OMLUNIQUEID})
same => n,GotoIf($["${DIALSTATUS}" != "ANSWER"]?queueLogNoAnswer)
same => n,GotoIf($["${ANSWEREDTIME}" == ""]?hangup)
same => n,Gosub(sub-oml-hangup,s,1)

same => n(queueLogNoAnswer),Set(OMLCALLWAITDURATION=${CDR(duration)})
same => n,Gosub(sub-oml-queuelog,s,1(${OMLCAMPID},${OMLUNIQUEID},dialer-dialout,${DIALSTATUS},${OMLOUTNUM},${OMLCODCLI},${OMLCALLTYPEID},${OMLCAMPTYPE},${OMLCALLWAITDURATION},${OMLCALLDURATION},,call))
same => n(hangup),Hangup()


[rip-dialer-trunk-chan]
; en las dialer call CHANNEL-1 no hace nada, salvo que haya sido un AMD entonces ahí hace un queuelog
include => rip-dialer-trunk-chan-custom

exten => s,1,Verbose(2, CHANNEL-1 postcall dialerCall)
same => n,GotoIf($["${OMLAMD}" == "1"]?dialerAMD)
same => n,Gosub(sub-oml-hangup,s,1)
same => n(dialerAMD),Gosub(sub-oml-queuelog,s,1(${OMLCAMPID},${OMLUNIQUEID},${OMLAGENTID},AMD,${OMLOUTNUM},${OMLCODCLI},${OMLCALLTYPEID},${OMLCAMPTYPE},,,,call))
same => n,Hangup()


[rip-dialer-agent-chan]
; en las dialer call, CHANNEL-2 actualiza el status del agente que atendio la llamada y nada más, salvo que ....
; el canal haya muerto por una transferencia, entonces se hace un QueueLog para registrar la misma
include => rip-dialer-agent-chan-custom

exten => s,1,Verbose(2, CHANNEL-2 postcall dialerCall)
same => n,Set(OMLUNIQUEID=${SHARED(OMLAGENTID,${OMLMOTHERCHAN})})
same => n,Set(DB(OML/AGENT/${OMLAGENTID}/STATUS)=READY:${EPOCH})
same => n,Hangup()


[rip-dialer-originate-queue-chan]
; Subrutina de postcall invocada por canales Local/XXXX.......;1 (WD Originate Context "Terminal")
; en las dialer, CHANNEL-4 cierra el QueueLog con el resultado de la Queue() y ejecuta el AGI omni-grabaciones.py - Agent <---- Queue()
include => rip-dialer-originate-queue-chan-custom

exten => s,1,Verbose(2, As above, So Below - CHANNEL4)
same => n,Set(OMLAGENTID=${CUT(MEMBERNAME,_,1)})

same => n,Verbose(2, check resultado de llamada DIALSTATUS - ${SHARED(OMLCALLSTATUS,${CHANNEL})} - hangup side: ${OMLSIDEHANGUP})

same => n,StopMixMonitor(${OMLRECFILENAME}.wav)
same => n,GotoIf($["${CUT(SHARED(OMLCALLSTATUS,${CHANNEL}),-,1)}" == "BT"]?blindTransfer)
same => n,GotoIf($["${CUT(SHARED(OMLCALLSTATUS,${CHANNEL}),-,1)}" == "CT"]?consultTransfer)
same => n,GotoIf($["${CUT(SHARED(OMLCALLSTATUS,${CHANNEL}),-,1)}" == "CAMPT"]?campTransfer)
same => n,GotoIf($["${CUT(SHARED(OMLCALLSTATUS,${CHANNEL}),-,1)}" == "BTOUT"]?blindTransferOutCall)
same => n,GotoIf($["${CUT(SHARED(OMLCALLSTATUS,${CHANNEL}),-,1)}" == "CTOUT"]?consultTransferOutCall)
same => n,GotoIf($["${QUEUESTATUS}" == "TIMEOUT"]?dialerExpire)
same => n,GotoIf($["${QUEUESTATUS}" == "FULL"]?campTransferFull)
same => n,GotoIf($["${ABANDONED}" == "TRUE"]?dialerAbandon)
same => n,GotoIf($["${OMLFAILOVER}" == "true" && "${SHARED(OMLFAILOVER,${OMLMOTHERCHAN})}" != "trueandconnect"]?failoverMotherQueue)
;same => n,GotoIf($["${SHARED(OMLANSWERTIMESTAMP,${CHANNEL})}" != ""]?inboundAttend:inboundAbandon)

; la llamada fue gestionada por un agente
same => n,GotoIf($["${OMLAMD}" == "1"]?dialerAmd)
same => n,GotoIf($["${QUEUESTATUS}" == "TIMEOUT"]?dialerExpire)
same => n,GotoIf($["${ABANDONED}" == "TRUE"]?dialerAbandon)
same => n,Goto(dialerAttend)

;la llamada fue descartada por AMD
same => n(dialerAmd),Verbose(2, AMD post-call)
same => n,Gosub(sub-oml-queuelog,s,1(${OMLCAMPID},${OMLUNIQUEID},,AMD,${OMLOUTNUM},${OMLCODCLI},${OMLCALLTYPEID},${OMLCAMPTYPE},${OMLCALLWAITDURATION},${OMLCALLDURATION},,call))
same => n,Hangup()

; la llamada dialer fue atendida por un agente
same => n(dialerAttend),StopMixMonitor(${OMLRECFILENAME}.wav)
same => n,Set(OMLCALLWAITDURATION=${SHARED(OMLCALLWAITDURATION,${CHANNEL})})
same => n,Set(OMLCALLDURATION=$[${EPOCH} - ${SHARED(OMLANSWERTIMESTAMP,${CHANNEL})}])
same => n,ExecIf($["${OMLSIDEHANGUP}" == "2"]?Set(COMPLETE=COMPLETEAGENT):Set(COMPLETE=COMPLETEOUTNUM))
same => n,ExecIf($["${SHARED(OMLRECFILENAME,${CHANNEL})}" != ""]?Set(OMLRECFILENAME=${SHARED(OMLRECFILENAME,${CHANNEL})}))
same => n,ExecIf($["${DB(OML/CAMP/${OMLCAMPID}/REC)}" == "True" || "${SHARED(OMLRECFILENAME,${CHANNEL})}" != ""]?AGI(omni-grabaciones.py,${OMLCALLTYPEID},${OMLCODCLI},${OMLOUTNUM},${OMLRECFILENAME},${OMLAGENTID},${OMLCAMPID},${STRFTIME(${EPOCH},,%Y-%m-%d %H:%M:%S)},${OMLUNIQUEID},${OMLCALLDURATION}):Verbose(2, recording not enable))
same => n,Gosub(sub-oml-queuelog,s,1(${OMLCAMPID},${OMLUNIQUEID},${OMLAGENTID},${COMPLETE},${OMLOUTNUM},${OMLCODCLI},${OMLCALLTYPEID},${OMLCAMPTYPE},${OMLCALLWAITDURATION},${OMLCALLDURATION},${OMLRECFILENAME},call))
same => n,Hangup()

; la llamada dialer expiro
same => n(dialerExpire),Verbose(2, TIMEOUT queue dialer call)
same => n,Set(OMLCALLWAITDURATION=$[${EPOCH} - ${OMLYEARZERO}])
same => n,Gosub(sub-oml-queuelog,s,1(${OMLCAMPID},${OMLUNIQUEID},,EXITWITHTIMEOUT,${OMLOUTNUM},${OMLCODCLI},${OMLCALLTYPEID},${OMLCAMPTYPE},${OMLCALLWAITDURATION},,,call))
same => n,UserEvent(AgentComplete,Queue: ${OMLCAMPQNAME},TalkTime: ${CT},Channel: ${CHANNEL})
same => n,Hangup()

; la llamada dialer fue un abandono
same => n(dialerAbandon),Verbose(2, ABANDON queue dialer call)
same => n,Set(OMLCALLWAITDURATION=$[${EPOCH} - ${OMLYEARZERO}])
same => n,Gosub(sub-oml-queuelog,s,1(${OMLCAMPID},${OMLUNIQUEID},,ABANDON,${OMLOUTNUM},${OMLCODCLI},${OMLCALLTYPEID},${OMLCAMPTYPE},${OMLCALLWAITDURATION},,,call))
same => n,UserEvent(AgentComplete,Queue: ${OMLCAMPQNAME},TalkTime: ${CT},Channel: ${CHANNEL})
same => n,Hangup()

; la llamada dialer fue descartada por exceder la cantidad de llamadas en cola
same => n(dialerFull),Verbose(2, FULL queue inbound call)
same => n,Gosub(sub-oml-queuelog,s,1(${OMLCAMPID},${OMLUNIQUEID},${OMLAGENTID},EXITWITHTIMEOUT,${OMLOUTNUM},${OMLCODCLI},${OMLCALLTYPEID},${OMLCAMPTYPE},${OMLCALLWAITDURATION},${OMLCALLDURATION},,call))
same => n,Gosub(sub-oml-hangup,s,1(NORMAL CLEARING: dialerFull queue Call))

; tratamiento post-call de llamadas Dialer transferidas de manera ciega hacia otro agente
same => n(blindTransfer),Verbose(2, ${CHANNEL} muere en una BT)
same => n,GotoIf($["${SHARED(OMLCALLSTATUS,${CHANNEL})}" != "BT-ANSWER"]?btUnanswer:btAnswer)

same => n(btUnanswer),Set(OMLCALLWAITDURATION=$[${EPOCH} - ${OMLYEARZEROTRANSFER}])
same => n,ExecIf($["${OMLCALLSTATUS}" == "BT-TRY"]?Set(OMLCALLSTATUS=BT-ABANDON))
same => n,Gosub(sub-oml-queuelog,s,1(${OMLCAMPID},${OMLUNIQUEID},${OMLAGENTTRANSFERDSTID},${OMLCALLSTATUS},${OMLOUTNUM},${OMLCODCLI},${OMLCALLTYPEID},${OMLCAMPTYPE},${OMLCALLWAITDURATION},${OMLCALLDURATION},${OMLRECFILENAME},call))
same => n,Hangup()

same => n(btAnswer),Set(OMLCALLWAITDURATION=${SHARED(OMLCALLWAITDURATION,${CHANNEL})})
same => n,Set(OMLCALLDURATION=$[${EPOCH} -  ${SHARED(OMLTRANSFERANSWERTIMESTAMP,${CHANNEL})}])
same => n,AGI(omni-grabaciones.py,${OMLCALLTYPEID},${OMLCODCLI},${OMLOUTNUM},${OMLRECFILENAME},${OMLAGENTID},${OMLCAMPID},${STRFTIME(${EPOCH},,%Y-%m-%d %H:%M:%S)},${OMLUNIQUEID},${OMLCALLDURATION})
same => n,Set(COMPLETE=COMPLETE-BT)
same => n,Gosub(sub-oml-queuelog,s,1(${OMLCAMPID},${OMLUNIQUEID},${OMLAGENTTRANSFERDSTID},${COMPLETE},${OMLOUTNUM},${OMLCODCLI},8,${OMLCAMPTYPE},${OMLCALLWAITDURATION},${OMLCALLDURATION},${OMLRECFILENAME},call))
same => n,Hangup()


; tratamiento post-call de llamadas Dialer transferidas de manera consultativa hacia otro agente
same => n(consultTransfer),Verbose(2, ${CHANNEL} muere en una CT)
same => n,GotoIf($["${SHARED(OMLCALLSTATUS,${CHANNEL})}" == "CT-ACCEPT"]?ctAccept)

same => n,Goto(dialerAttend)

same => n(ctAccept),Set(OMLCALLWAITDURATION=${SHARED(OMLCALLTRANSFERWAITDURATION,${OMLMOTHERCHAN})})
same => n,Set(OMLCALLDURATION=$[${EPOCH} - ${SHARED(OMLTRANSFERANSWERTIMESTAMP,${OMLMOTHERCHAN})}])
same => n,Set(OMLAGENTID=${SHARED(OMLAGENTTRANSFERID,${OMLMOTHERCHAN})})
same => n,Set(COMPLETE=COMPLETE-CT)
same => n,AGI(omni-grabaciones.py,${OMLCALLTYPEID},${OMLCAMPID},${OMLOUTNUM},${OMLRECFILENAME},${OMLAGENTID},${OMLCAMPID},${STRFTIME(${EPOCH},,%Y-%m-%d %H:%M:%S)},${OMLUNIQUEID},${OMLCALLDURATION})
same => n,Gosub(sub-oml-queuelog,s,1(${OMLCAMPID},${OMLUNIQUEID},${OMLAGENTID},${COMPLETE},${OMLOUTNUM},${OMLCODCLI},8,${OMLCAMPTYPE},${OMLCALLWAITDURATION},${OMLCALLDURATION},${OMLRECFILENAME},call))
same => n,Hangup()

; tratamiento post-call de llamadas Dialer transferidas a otra campaña
same => n(campTransfer),GotoIf($["${SHARED(OMLCALLSTATUS,${CHANNEL})}" == "CAMPT-ANSWER"]?camptAnswer)

same => n(campTransferFail),Verbose(2, campTransfer Fail)
same => n,AGI(omni-grabaciones.py,${OMLCALLTYPEID},${OMLCODCLI},${OMLOUTNUM},${OMLRECFILENAME},${OMLAGENTID},${OMLCAMPID},${STRFTIME(${EPOCH},,%Y-%m-%d %H:%M:%S)},${OMLUNIQUEID},${OMLCALLDURATION})
same => n,Gosub(sub-oml-queuelog,s,1(${OMLCAMPID},${OMLUNIQUEID},${OMLAGENTID},CAMPT-FAIL,${OMLOUTNUM},${OMLCODCLI},8,${OMLCAMPTYPE},${OMLCALLWAITDURATION},${OMLCALLDURATION},${OMLRECFILENAME},call))
same => n,GotoIf($["${QUEUESTATUS}" == "TIMEOUT"]?campTransferExpire)
same => n,GotoIf($["${QUEUESTATUS}" == "FULL"]?campTransferFull)
same => n,GotoIf($["${ABANDONED}" == "TRUE"]?campTransferAbandon)

same => n(campTransferExpire),Verbose(2, TIMEOUT queue dialer call)
same => n,Set(OMLCALLWAITDURATION=$[${EPOCH} - ${OMLYEARZEROTRANSFER}])
same => n,Gosub(sub-oml-queuelog,s,1(${OMLCAMPTRANSFERID},${OMLUNIQUEID},,EXITWITHTIMEOUT,${OMLOUTNUM},${OMLCODCLI},8,${OMLCAMPDSTTYPE},${OMLCALLWAITDURATION},,${OMLRECFILENAME},call))
same => n,Hangup()

same => n(campTransferFull),Verbose(2, FULL queue dialer call)
same => n,Set(OMLCALLWAITDURATION=$[${EPOCH} - ${OMLYEARZEROTRANSFER}])
same => n,Gosub(sub-oml-queuelog,s,1(${OMLCAMPTRANSFERID},${OMLUNIQUEID},,EXITWITHTIMEOUT,${OMLOUTNUM},${OMLCODCLI},8,${OMLCAMPDSTTYPE},${OMLCALLWAITDURATION},,${OMLRECFILENAME},call))
same => n,Gosub(sub-oml-hangup,s,1)

same => n(campTransferAbandon),Verbose(2, ABANDON queue dialer call)
same => n,Set(OMLCALLWAITDURATION=$[${EPOCH} - ${OMLYEARZEROTRANSFER}])
same => n,Gosub(sub-oml-queuelog,s,1(${OMLCAMPTRANSFERID},${OMLUNIQUEID},,ABANDON,${OMLOUTNUM},${OMLCODCLI},8,${OMLCAMPDSTTYPE},${OMLCALLWAITDURATION},,${OMLRECFILENAME},call))
same => n,Hangup()

same => n,Gosub(sub-oml-hangup,s,1(NORMAL CLEARING - ${CONTEXT}))

same => n(camptAnswer),Set(OMLCALLDURATION=$[${EPOCH} - ${SHARED(OMLTRANSFERANSWERTIMESTAMP,${OMLMOTHERCHAN})}])
same => n,Set(OMLCALLWAITDURATION=${SHARED(OMLCALLTRANSFERWAITDURATION,${OMLMOTHERCHAN})})
same => n,AGI(omni-grabaciones.py,${OMLCALLTYPEID},${OMLCODCLI},${OMLOUTNUM},${OMLRECFILENAME},${OMLAGENTID},${OMLCAMPID},${STRFTIME(${EPOCH},,%Y-%m-%d %H:%M:%S)},${OMLUNIQUEID},${OMLCALLDURATION})
same => n,Set(__OMLAGENTID=${CUT(MEMBERNAME,_,1)})
same => n,Set(__OMLCAMPIDTRANSFER=${OMLCAMPTRANSFERID})
same => n,Set(__OMLCAMPTYPE=3)

same => n,Set(COMPLETE=COMPLETE-CAMPT)
same => n,Gosub(sub-oml-queuelog,s,1(${OMLCAMPIDTRANSFER},${OMLUNIQUEID},${OMLAGENTID},${COMPLETE},${OMLOUTNUM},${OMLCODCLI},8,${OMLCAMPTYPE},${OMLCALLWAITDURATION},${OMLCALLDURATION},${OMLRECFILENAME},call))
same => n,Hangup()


; tratamiento post-call de llamadas Dialer transferidas de manera ciega hacia un trunk externo
same => n(blindTransferOutCall),Verbose(2, ${CHANNEL} muere en una BT)
same => n,GotoIf($["${SHARED(OMLCALLSTATUS,${CHANNEL})}" != "BTOUT-ANSWER"]?btOutUnanswer:btOutAnswer)

same => n(btOutUnanswer),Set(OMLCALLWAITDURATION=$[${EPOCH} - ${OMLYEARZEROTRANSFER}])
same => n,ExecIf($["${OMLCALLSTATUS}" == "BTOUT-TRY"]?Set(OMLCALLSTATUS=BTOUT-ABANDON))
same => n,Gosub(sub-oml-queuelog,s,1(${OMLCAMPID},${OMLUNIQUEID},${OMLOUTNUMTRANSFER},${OMLCALLSTATUS},${OMLOUTNUM},${OMLCODCLI},${OMLCALLTYPEID},${OMLCAMPTYPE},${OMLCALLWAITDURATION},${OMLCALLDURATION},${OMLRECFILENAME},call))
same => n,Hangup()

same => n(btOutAnswer),Set(OMLCALLWAITDURATION=${SHARED(OMLCALLWAITDURATION,${CHANNEL})})
same => n,Set(OMLCALLDURATION=$[${EPOCH} -  ${SHARED(OMLTRANSFERANSWERTIMESTAMP,${CHANNEL})}])
same => n,AGI(omni-grabaciones.py,${OMLCALLTYPEID},${OMLCODCLI},${OMLOUTNUM},${OMLRECFILENAME},${OMLAGENTID},${OMLCAMPID},${STRFTIME(${EPOCH},,%Y-%m-%d %H:%M:%S)},${OMLUNIQUEID},${OMLCALLDURATION})
same => n,Set(COMPLETE=COMPLETE-BTOUT)
same => n,Gosub(sub-oml-queuelog,s,1(${OMLCAMPID},${OMLUNIQUEID},${OMLOUTNUMTRANSFER},${COMPLETE},${OMLOUTNUM},${OMLCODCLI},9,${OMLCAMPTYPE},${OMLCALLWAITDURATION},${OMLCALLDURATION},${OMLRECFILENAME},call))
same => n,Hangup()


; tratamiento post-call de llamadas Dialer transferidas de manera consultativa hacia un trunk externo
same => n(consultTransferOutCall),Verbose(2, ${CHANNEL} muere en una CT)
same => n,GotoIf($["${SHARED(OMLCALLSTATUS,${CHANNEL})}" == "CTOUT-ACCEPT"]?ctOutAccept)

same => n,Goto(dialerAttend)

same => n(ctOutAccept),Set(OMLCALLWAITDURATION=${SHARED(OMLCALLTRANSFERWAITDURATION,${OMLMOTHERCHAN})})
same => n,Set(OMLCALLDURATION=$[${EPOCH} - ${SHARED(OMLTRANSFERANSWERTIMESTAMP,${OMLMOTHERCHAN})}])
same => n,Set(OMLAGENTID=${SHARED(OMLAGENTTRANSFERID,${OMLMOTHERCHAN})})
same => n,Set(COMPLETE=COMPLETE-CTOUT)
same => n,AGI(omni-grabaciones.py,${OMLCALLTYPEID},${OMLCAMPID},${OMLOUTNUM},${OMLRECFILENAME},${OMLAGENTID},${OMLCAMPID},${STRFTIME(${EPOCH},,%Y-%m-%d %H:%M:%S)},${OMLUNIQUEID},${OMLCALLDURATION})
same => n,Gosub(sub-oml-queuelog,s,1(${OMLCAMPID},${OMLUNIQUEID},${SHARED(OMLOUTNUMTRANSFER,${CHANNEL})},${COMPLETE},${OMLOUTNUM},${OMLCODCLI},9,${OMLCAMPTYPE},${OMLCALLWAITDURATION},${OMLCALLDURATION},${OMLRECFILENAME},call))
same => n,Hangup()





; TRANSFERS RIP CHANNELS TRANSFERS RIP CHANNELS TRANSFERS RIP CHANNELS TRANSFERS RIP CHANNELS TRANSFERS RIP CHANNELS TRANSFERS RIP CHANNELS
; TRANSFERS RIP CHANNELS TRANSFERS RIP CHANNELS TRANSFERS RIP CHANNELS TRANSFERS RIP CHANNELS TRANSFERS RIP CHANNELS TRANSFERS RIP CHANNELS
; TRANSFERS RIP CHANNELS TRANSFERS RIP CHANNELS TRANSFERS RIP CHANNELS TRANSFERS RIP CHANNELS TRANSFERS RIP CHANNELS TRANSFERS RIP CHANNELS
; TRANSFERS RIP CHANNELS TRANSFERS RIP CHANNELS TRANSFERS RIP CHANNELS TRANSFERS RIP CHANNELS TRANSFERS RIP CHANNELS TRANSFERS RIP CHANNELS

[rip-ctransfer-aux-channel]
include => rip-ctransfer-aux-channel-custom

; post call para canal auxiliar en transferencia consultativa AG2AG
exten => s,1,Verbose(2, RIP aux consultative transfer channels)
same => n(ag2agConsultTransferAux),Verbose(2, CHANNEL-2 postcall ag2agConsultTransferAux)

same => n(consultTransferAuxContinue),GotoIf($["${DIALSTATUS}" != "ANSWER"]?notAnswerTransfer)

same => n,GotoIf($["${CHANNELS(${TRANSFERERNAME})}" == ""]?ctAccept)
same => n,GotoIf($["${CHANNELS(${DIALEDPEERNAME})}" == ""]?ctDiscard)

same => n,Gosub(sub-oml-hangup,s,1)

same => n(notAnswerTransfer),Verbose(2, transferencia no atendida)
same => n,ExecIf($[${ISNULL(${DIALSTATUS})} || "${DIALSTATUS}" == "CANCEL"]?:Set(SHARED(OMLCALLSTATUS,${OMLMOTHERCHAN})=CT-${DIALSTATUS}))
same => n,Gosub(sub-oml-queuelog,s,1(${OMLCAMPID},${OMLUNIQUEID},${OMLAGENTTRANSFERDSTID},CT-${DIALSTATUS},${OMLOUTNUM},${OMLCODCLI},8,${OMLCAMPTYPE},,,,call))
same => n,Gosub(sub-oml-hangup,s,1)

same => n(ctAccept),Verbose(2, CT-ACCEPT)
same => n,Set(SHARED(OMLCALLSTATUS,${OMLMOTHERCHAN})=CT-ACCEPT)
same => n,Gosub(sub-oml-queuelog,s,1(${OMLCAMPID},${OMLUNIQUEID},${OMLAGENTTRANSFERDSTID},CT-ACCEPT,${OMLOUTNUM},${OMLCODCLI},8,${OMLCAMPTYPE},,,,call))
same => n,Gosub(sub-oml-hangup,s,1)

same => n(ctDiscard),Verbose(2, CT-DISCARD)
same => n,Set(SHARED(OMLCALLSTATUS,${OMLMOTHERCHAN})=CT-DISCARD)
same => n,Gosub(sub-oml-queuelog,s,1(${OMLCAMPID},${OMLUNIQUEID},${OMLAGENTTRANSFERDSTID},CT-DISCARD,${OMLOUTNUM},${OMLCODCLI},8,${OMLCAMPTYPE},,,,call))
same => n,Gosub(sub-oml-hangup,s,1)


[rip-ctransfer-ag2-channel]
; post call sobre un agente que recibió una transferencia consultativa
include => rip-ctransfer-ag2-channel-custom

exten => s,1,Verbose(2, RIP ag2 consultative transfer channel)
same => n(ag2agConsultTransferDst),Verbose(2, CHANNEL-2 postcall transferAgent2Agent)
same => n,Set(DB(OML/AGENT/${OMLAGENTID}/STATUS)=READY:${EPOCH})
same => n,Gosub(sub-oml-hangup,s,1)


[rip-ctout-aux-chan]
; post call para canal auxiliar en transferencia consultativa AG2OUT
include => rip-ctout-aux-chan-custom

exten => s,1,Verbose(2, CHANNEL postcall ag2OutConsultTransferAux)

same => n,GotoIf($["${DIALSTATUS}" != "ANSWER"]?notAnswerTransfer)

same => n,GotoIf($["${CHANNELS(${TRANSFERERNAME})}" == ""]?ctAccept)
same => n,GotoIf($["${CHANNELS(${DIALEDPEERNAME})}" == ""]?ctDiscard)

same => n,Gosub(sub-oml-hangup,s,1)

same => n(notAnswerTransfer),Verbose(2, transferencia no atendida)
same => n,ExecIf($[${ISNULL(${DIALSTATUS})} || "${DIALSTATUS}" == "CANCEL"]?:Set(SHARED(OMLCALLSTATUS,${OMLMOTHERCHAN})=CTOUT-${DIALSTATUS}))
same => n,Gosub(sub-oml-queuelog,s,1(${OMLCAMPID},${OMLUNIQUEID},${OMLOUTNUMTRANSFER},CTOUT-${DIALSTATUS},${OMLOUTNUM},${OMLCODCLI},9,${OMLCAMPTYPE},,,,call))
same => n,Gosub(sub-oml-hangup,s,1)

same => n(ctAccept),Verbose(2, CT-ACCEPT)
same => n,Set(SHARED(OMLCALLSTATUS,${OMLMOTHERCHAN})=CTOUT-ACCEPT)
same => n,Gosub(sub-oml-queuelog,s,1(${OMLCAMPID},${OMLUNIQUEID},${OMLOUTNUMTRANSFER},CTOUT-ACCEPT,${OMLOUTNUM},${OMLCODCLI},9,${OMLCAMPTYPE},,,,call))
same => n,Gosub(sub-oml-hangup,s,1)

same => n(ctDiscard),Verbose(2, CT-DISCARD)
same => n,Set(SHARED(OMLCALLSTATUS,${OMLMOTHERCHAN})=CTOUT-DISCARD)
same => n,Gosub(sub-oml-queuelog,s,1(${OMLCAMPID},${OMLUNIQUEID},${OMLOUTNUMTRANSFER},CTOUT-DISCARD,${OMLOUTNUM},${OMLCODCLI},9,${OMLCAMPTYPE},,,,call))
same => n,Gosub(sub-oml-hangup,s,1)


[rip-btout-transfer-trunk-chan]
include => rip-btout-transfer-trunk-chan-custom

exten => s,1,Verbose(2, CHANNEL postcall ag2OutBlindTransfer)
same => n,Gosub(sub-oml-hangup,s,1)
